/*
 *   SONEWS News Server
 *   see AUTHORS for the list of contributors
 *
 *   This program is free software: you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation, either version 3 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
package org.sonews.storage.impl;

import java.sql.SQLException;
import java.util.Collections;
import java.util.List;
import java.util.logging.Level;
import org.sonews.feed.Subscription;
import org.sonews.storage.Article;
import org.sonews.storage.ArticleHead;
import org.sonews.storage.Group;
import org.sonews.storage.Storage;
import org.sonews.storage.StorageBackendException;
import org.sonews.util.Log;
import org.sonews.util.Pair;

/**
 *
 * @author František Kučera (frantovo.cz)
 */
public class DrupalDatabase implements Storage {

	/**
	 * Rises the database: reconnect and recreate all prepared statements.
	 * @throws java.lang.SQLException
	 */
	protected void arise() throws SQLException {
	}

	@Override
	public void addArticle(Article art) throws StorageBackendException {
		Log.get().log(Level.SEVERE, "TODO: addArticle {0}", new Object[]{art});
	}

	@Override
	public void addEvent(long timestamp, int type, long groupID) throws StorageBackendException {
		Log.get().log(Level.SEVERE, "TODO: addEvent {0} / {1} / {2}", new Object[]{timestamp, type, groupID});
	}

	@Override
	public void addGroup(String groupname, int flags) throws StorageBackendException {
		Log.get().log(Level.SEVERE, "TODO: addGroup {0} / {1}", new Object[]{groupname, flags});
	}

	@Override
	public int countArticles() throws StorageBackendException {
		Log.get().log(Level.SEVERE, "TODO: countArticles");
		return 0;
	}

	@Override
	public int countGroups() throws StorageBackendException {
		Log.get().log(Level.SEVERE, "TODO: countGroups");
		return 0;
	}

	@Override
	public void delete(String messageID) throws StorageBackendException {
		Log.get().log(Level.SEVERE, "TODO: delete {0}", new Object[]{messageID});
	}

	@Override
	public Article getArticle(String messageID) throws StorageBackendException {
		Log.get().log(Level.SEVERE, "TODO: getArticle {0}", new Object[]{messageID});
		/** TODO: */
		return null;
	}

	@Override
	public Article getArticle(long articleIndex, long groupID) throws StorageBackendException {
		Log.get().log(Level.SEVERE, "TODO: getArticle {0} / {1}", new Object[]{articleIndex, groupID});
		/** TODO: */
		return null;
	}

	@Override
	public List<Pair<Long, ArticleHead>> getArticleHeads(Group group, long first, long last) throws StorageBackendException {
		Log.get().log(Level.SEVERE, "TODO: getArticleHeads {0} / {1} / {2}", new Object[]{group, first, last});
		/** TODO: */
		return Collections.emptyList();
	}

	@Override
	public List<Pair<Long, String>> getArticleHeaders(Group group, long start, long end, String header, String pattern) throws StorageBackendException {
		Log.get().log(Level.SEVERE, "TODO: getArticleHeaders {0} / {1} / {2} / {3} / {4}", new Object[]{group, start, end, header, pattern});
		/** TODO: */
		return Collections.emptyList();
	}

	@Override
	public long getArticleIndex(Article art, Group group) throws StorageBackendException {
		Log.get().log(Level.SEVERE, "TODO: getArticleIndex {0} / {1}", new Object[]{art, group});
		/** TODO: */
		return 0;
	}

	@Override
	public List<Long> getArticleNumbers(long groupID) throws StorageBackendException {
		Log.get().log(Level.SEVERE, "TODO: getArticleNumbers {0}", new Object[]{groupID});
		/** TODO: */
		return Collections.emptyList();
	}

	@Override
	public String getConfigValue(String key) throws StorageBackendException {
		Log.get().log(Level.SEVERE, "TODO: getConfigValue {0}", new Object[]{key});
		return null;
	}

	@Override
	public int getEventsCount(int eventType, long startTimestamp, long endTimestamp, Group group) throws StorageBackendException {
		Log.get().log(Level.SEVERE, "TODO: getEventsCount {0} / {1} / {2} / {3}", new Object[]{eventType, startTimestamp, endTimestamp, group});
		return 0;
	}

	@Override
	public double getEventsPerHour(int key, long gid) throws StorageBackendException {
		Log.get().log(Level.SEVERE, "TODO: getEventsPerHour {0} / {1}", new Object[]{key, gid});
		return 0;
	}

	@Override
	public int getFirstArticleNumber(Group group) throws StorageBackendException {
		Log.get().log(Level.SEVERE, "TODO: getFirstArticleNumber {0}", new Object[]{group});
		/** TODO: */
		return 0;
	}

	@Override
	public Group getGroup(String name) throws StorageBackendException {
		Log.get().log(Level.SEVERE, "TODO: getGroup {0}", new Object[]{name});
		/** TODO: */
		return null;
	}

	@Override
	public List<Group> getGroups() throws StorageBackendException {
		Log.get().log(Level.SEVERE, "TODO: getGroups");
		/** TODO: */
		return Collections.emptyList();
	}

	@Override
	public List<String> getGroupsForList(String listAddress) throws StorageBackendException {
		Log.get().log(Level.SEVERE, "TODO: getGroupsForList {0}", new Object[]{listAddress});
		return Collections.emptyList();
	}

	@Override
	public int getLastArticleNumber(Group group) throws StorageBackendException {
		Log.get().log(Level.SEVERE, "TODO: getLastArticleNumber {0}", new Object[]{group});
		/** TODO: */
		return 0;
	}

	@Override
	public List<String> getListsForGroup(String groupname) throws StorageBackendException {
		Log.get().log(Level.SEVERE, "TODO: getListsForGroup {0}", new Object[]{groupname});
		return Collections.emptyList();
	}

	@Override
	public String getOldestArticle() throws StorageBackendException {
		Log.get().log(Level.SEVERE, "TODO: getOldestArticle");
		return null;
	}

	@Override
	public int getPostingsCount(String groupname) throws StorageBackendException {
		Log.get().log(Level.SEVERE, "TODO: getPostingsCount {0}", new Object[]{groupname});
		return 0;
	}

	@Override
	public List<Subscription> getSubscriptions(int type) throws StorageBackendException {
		Log.get().log(Level.SEVERE, "TODO: getSubscriptions {0}", new Object[]{type});
		return Collections.emptyList();
	}

	@Override
	public boolean isArticleExisting(String messageID) throws StorageBackendException {
		Log.get().log(Level.SEVERE, "TODO: isArticleExisting {0}", new Object[]{messageID});
		/** TODO: */
		return false;
	}

	@Override
	public boolean isGroupExisting(String groupname) throws StorageBackendException {
		Log.get().log(Level.SEVERE, "TODO: isGroupExisting {0}", new Object[]{groupname});
		/** TODO: */
		return false;
	}

	@Override
	public void purgeGroup(Group group) throws StorageBackendException {
		Log.get().log(Level.SEVERE, "TODO: purgeGroup {0}", new Object[]{group});
	}

	@Override
	public void setConfigValue(String key, String value) throws StorageBackendException {
		Log.get().log(Level.SEVERE, "TODO: setConfigValue {0} = {1}", new Object[]{key, value});
	}

	@Override
	public boolean update(Article article) throws StorageBackendException {
		Log.get().log(Level.SEVERE, "TODO: update {0}", new Object[]{article});
		throw new StorageBackendException("Not implemented yet.");
	}

	@Override
	public boolean update(Group group) throws StorageBackendException {
		Log.get().log(Level.SEVERE, "TODO: update {0}", new Object[]{group});
		throw new StorageBackendException("Not implemented yet.");
	}
}
